## gpsd 3.17

=== SConstruct ===
# SCons build recipe for the GPSD project

# Important targets:
#
# build      - build the software (default)
# dist       - make distribution tarball
# install    - install programs, libraries, and manual pages
# uninstall  - undo an install
#
# check      - run regression and unit tests.
# audit      - run code-auditing tools
# testbuild  - test-build the code from a tarball
# website    - refresh the website
# release    - ship a release
#
# --clean    - clean all normal build targets
# sconsclean - clean up scons dotfiles (but not the database)
#
# Setting the DESTDIR environment variable will prefix the install destinations
# without changing the --prefix prefix.

# Unfinished items:
# * Out-of-directory builds: see http://www.scons.org/wiki/UsingBuildDir
# * Coveraging mode: gcc "-coverage" flag requires a hack
#   for building the python bindings

# Release identification begins here
gpsd_version = "3.17"

# client library version
libgps_version_current = 23
libgps_version_revision = 0
libgps_version_age = 0

# Release identification ends here

# Hosting information (mainly used for templating web pages) begins here
# Each variable foo has a corresponding @FOO@ expanded in .in files.
# There are no project-dependent URLs or references to the hosting site
# anywhere else in the distribution; preserve this property!
sitename = "Savannah"
sitesearch = "catb.org"
website = "http://catb.org/gpsd"
mainpage = "https://savannah.nongnu.org/projects/gpsd/"
webupload = "login.ibiblio.org:/public/html/catb/gpsd"
cgiupload = "root@thyrsus.com:/var/www/cgi-bin/"
scpupload = "dl.sv.nongnu.org:/releases/gpsd/"
mailman = "https://lists.nongnu.org/mailman/listinfo/"
admin = "https://savannah.nongnu.org/project/admin/?group=gpsd"
download = "http://download-mirror.savannah.gnu.org/releases/gpsd/"
bugtracker = "https://savannah.nongnu.org/bugs/?group=gpsd"
browserepo = "http://git.savannah.gnu.org/cgit/gpsd.git"
clonerepo = "https://savannah.nongnu.org/git/?group=gpsd"
gitrepo = "git://git.savannah.nongnu.org/gpsd.git"
webform = "http://www.thyrsus.com/cgi-bin/gps_report.cgi"
formserver = "www@thyrsus.com"
devmail = "gpsd-dev@lists.nongnu.org"
usermail = "gpsd-users@lists.nongnu.org"
annmail = "gpsd-announce@nongnu.org"
ircchan = "irc://chat.freenode.net/#gpsd"
tiplink = "<a href='https://www.patreon.com/esr'>" \
          "leave a remittance at Patreon</a>"
tipwidget = '<p><a href="https://www.patreon.com/esr">' \
            'Donate here to support continuing development.</a></p>'
# Hosting information ends here

EnsureSConsVersion(2, 3, 0)

import ast
import copy
import glob
import operator
import os
import platform
import re
import subprocess
import sys
import time
from distutils import sysconfig
from distutils.util import get_platform
import SCons

PYTHON_SYSCONFIG_IMPORT = 'from distutils import sysconfig'

# replacement for functions from the commands module, which is deprecated.
import subprocess


def _getstatusoutput(cmd, input=None, shell=True, cwd=None, env=None):
    pipe = subprocess.Popen(cmd, shell=shell, cwd=cwd, env=env,
                            stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    (output, errout) = pipe.communicate(input=input)
    status = pipe.returncode
    return (status, output)


def _getoutput(cmd, input=None, shell=True, cwd=None, env=None):
    return _getstatusoutput(cmd, input, shell, cwd, env)[1]


# Spawn replacement that suppresses non-error stderr
def filtered_spawn(sh, escape, cmd, args, env):
    proc = subprocess.Popen([sh, '-c', ' '.join(args)],
                            env=env, close_fds=True, stderr=subprocess.PIPE)
    _, stderr = proc.communicate()
    if proc.returncode:
        sys.stderr.write(stderr)
    return proc.returncode

#
# Build-control options
#

# Start by reading configuration variables from the cache
opts = Variables('.scons-option-cache')

systemd_dir = '/lib/systemd/system'
systemd = os.path.exists(systemd_dir)

# Set distribution-specific defaults here
imloads = True

boolopts = (
    # GPS protocols
    ("nmea0183",      True,  "NMEA0183 support"),
    ("ashtech",       True,  "Ashtech support"),
    ("earthmate",     True,  "DeLorme EarthMate Zodiac support"),
    ("evermore",      True,  "EverMore binary support"),
    ("fv18",          True,  "San Jose Navigation FV-18 support"),
    ("garmin",        True,  "Garmin kernel driver support"),
    ("garmintxt",     True,  "Garmin Simple Text support"),
    ("geostar",       True,  "Geostar Protocol support"),
    ("itrax",         True,  "iTrax hardware support"),
    ("mtk3301",       True,  "MTK-3301 support"),
    ("navcom",        True,  "Navcom NCT support"),
    ("oncore",        True,  "Motorola OnCore chipset support"),
    ("sirf",          True,  "SiRF chipset support"),
    ("skytraq",       True,  "Skytraq chipset support"),
    ("superstar2",    True,  "Novatel SuperStarII chipset support"),
    ("tnt",           True,  "True North Technologies support"),
    ("tripmate",      True,  "DeLorme TripMate support"),
    ("tsip",          True,  "Trimble TSIP support"),
    ("ublox",         True,  "u-blox Protocol support"),
    ("fury",          True,  "Jackson Labs Fury and Firefly support"),
    ("nmea2000",      True,  "NMEA2000/CAN support"),
    # Non-GPS protocols
    ("aivdm",         True,  "AIVDM support"),
    ("gpsclock",      True,  "GPSClock support"),
    ("ntrip",         True,  "NTRIP support"),
    ("oceanserver",   True,  "OceanServer support"),
    ("isync",         True,  "Spectratime iSync LNRClok/GRCLOK support"),
    ("rtcm104v2",     True,  "rtcm104v2 support"),
    ("rtcm104v3",     True,  "rtcm104v3 support"),
    ("passthrough",   True,  "build support for passing through JSON"),
    # Time service
    ("ntp",           True,  "NTP time hinting support"),
    ("ntpshm",        True,  "NTP time hinting via shared memory"),
    ("pps",           True,  "PPS time syncing support"),
    ("oscillator",    True,  "Disciplined oscillator support"),
    # Export methods
    ("socket_export", True,  "data export over sockets"),
    ("dbus_export",   True,  "enable DBUS export support"),
    ("shm_export",    True,  "export via shared memory"),
    # Communication
    ('usb',           True,  "libusb support for USB devices"),
    ("bluez",         True,  "BlueZ support for Bluetooth devices"),
    ("ipv6",          True,  "build IPv6 support"),
    ("netfeed",       True,  "build support for handling TCP/IP data sources"),
    # Other daemon options
    ("force_global",  False, "force daemon to listen on all addressses"),
    ("timing",        False, "latency timing support"),
    ("control_socket", True,  "control socket for hotplug notifications"),
    ("systemd",       systemd, "systemd socket activation"),
    # Client-side options
    ("clientdebug",   True,  "client debugging support"),
    ("ncurses",       True,  "build with ncurses"),
    ("libgpsmm",      True,  "build C++ bindings"),
    ("qt",            True,  "build QT bindings"),
    # Daemon options
    ("reconfigure",   True,  "allow gpsd to change device settings"),
    ("controlsend",   True,  "allow gpsctl/gpsmon to change device settings"),
    ("nofloats", False, "float ops are expensive, suppress error estimates"),
    ("squelch",       False, "squelch gpsd_log/gpsd_hexdump to save cpu"),
    # Build control
    ("gpsd",          True,  "gpsd itself"),
    ("gpsdclients",   True,  "gspd client programs"),
    ("shared",        True,  "build shared libraries, not static"),
    ("implicit_link", imloads, "implicit linkage is supported in shared libs"),
    ("python",        True,  "build Python support and modules."),
    ("debug",         False, "include debug information in build"),
    ("profiling",     False, "build with profiling enabled"),
    ("coveraging",    False, "build with code coveraging enabled"),
    ("nostrip",       False, "don't symbol-strip binaries at link time"),
    ("manbuild",      True,  "build help in man and HTML formats"),
    ("leapfetch",     True,  "fetch up-to-date data on leap seconds."),
    ("minimal", False, "turn off every option not set on the command line"),
    ("timeservice",   False, "time-service configuration"),
    ("magic_hat", sys.platform.startswith('linux'),
     "special Linux PPS hack for Raspberry Pi et al"),
    ("xgps",          True,  "include xgps and xgpsspeed."),
    # Test control
    ("slow",          False, "run tests with realistic (slow) delays"),
)

for (name, default, help) in boolopts:
    opts.Add(BoolVariable(name, help, default))

# Gentoo, Fedora, opensuse systems use uucp for ttyS* and ttyUSB*
if os.path.exists("/etc/gentoo-release"):
    def_group = "uucp"
else:
    def_group = "dialout"

nonboolopts = (
    ("gpsd_user",        "nobody",      "privilege revocation user",),
    ("gpsd_group",       def_group,     "privilege revocation group"),
    ("prefix",           "/usr/local",  "installation directory prefix"),
    ("target_python",    "python",      "target Python version as command"),
    ("python_libdir",    "",            "Python module directory prefix"),
    ("max_clients",      '64',          "maximum allowed clients"),
    ("max_devices",      '4',           "maximum allowed devices"),
    ("fixed_port_speed", 0,             "fixed serial port speed"),
    ("fixed_stop_bits",  0,             "fixed serial port stop bits"),
    ("target",           "",            "cross-development target"),
    ("sysroot",          "",            "cross-development system root"),
    ("qt_versioned",     "",            "version for versioned Qt"),
    ("python_coverage",  "coverage run", "coverage command for Python progs"),
)

for (name, default, help) in nonboolopts:
    opts.Add(name, help, default)

pathopts = (
    ("sysconfdir",          "etc",           "system configuration directory"),
    ("bindir",              "bin",           "application binaries directory"),
    ("includedir",          "include",       "header file directory"),
    ("libdir",              "lib",           "system libraries"),
    ("sbindir",             "sbin",          "system binaries directory"),
    ("mandir",              "share/man",     "manual pages directory"),
    ("docdir",              "share/doc",     "documents directory"),
    ("udevdir",             "/lib/udev",     "udev rules directory"),
    ("pkgconfig",           "$libdir/pkgconfig", "pkgconfig file directory"),
)

for (name, default, help) in pathopts:
    opts.Add(PathVariable(name, help, default, PathVariable.PathAccept))

#
# Environment creation
#
import_env = (
    "DISPLAY",         # Required for dia to run under scons
    "GROUPS",          # Required by gpg
    "HOME",            # Required by gpg
    "LOGNAME",         # LOGNAME is required for the flocktest production.
    "MACOSX_DEPLOYMENT_TARGET",  # Required by MacOSX 10.4 and probably earlier
    'PATH',            # Required for ccache and Coverity scan-build
    # Pass more environment variables to pkg-config (required for crossbuilds)
    'PKG_CONFIG_LIBDIR',
    'PKG_CONFIG_PATH',  # Set .pc file directory in a crossbuild
    # Pass more environment variables to pkg-config (required for crossbuilds)
    'PKG_CONFIG_SYSROOT_DIR',
    'STAGING_DIR',     # Required by the OpenWRT and CeroWrt builds.
    'STAGING_PREFIX',  # Required by the OpenWRT and CeroWrt builds.
    'WRITE_PAD',       # So we can test WRITE_PAD values on the fly.
)

envs = {}
for var in import_env:
    if var in os.environ:
        envs[var] = os.environ[var]
envs["GPSD_HOME"] = os.getcwd()

env = Environment(tools=["default", "tar", "textfile"], options=opts, ENV=envs)

#  Minimal build turns off every option not set on the command line,
if ARGUMENTS.get('minimal'):
    for (name, default, help) in boolopts:
        # Ensure gpsd and gpsdclients are always enabled unless explicitly
        # turned off.
        if ((default is True
             and not ARGUMENTS.get(name)

=== contrib/SConstruct ===
# This is a skeleton recipe to simplify building some of these little
# utilities. They probably won't be useful to many users, and they probably
# won't get used on a daily basis, but someone might find them useful for
# tinkering with their gear.

# Note that ../gpsd_config.h is required and is built separately


strl = StaticObject("strl", "../strl.c")

ashctl = Program("ashctl", ["ashctl.c", strl])
binlog = Program("binlog", "binlog.c")
binreplay = Program("binreplay", "binreplay.c", parse_flags=['-lutil'])
lla2ecef = Program("lla2ecef", "lla2ecef.c", parse_flags=['-lm'])
motosend = Program("motosend", ["motosend.c", strl])

Default(ashctl, binlog, binreplay, lla2ecef, motosend)

=== debian/changelog ===
gpsd (3.17-7~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports. (Closes: #902243)
  * [378b7af6] Revert "Allow gpsd.service to be enabled by the
    admin at boot time." - Not compatible with stretch.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 28 Jul 2019 00:20:39 +0200

gpsd (3.17-7) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * [ffb32ff8] Allow gpsd.service to be enabled by the admin at boot time.
    Be sure to keep it disabled. The admin needs to explicitely start
    it if needed.
    Closes: #928681

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 25 May 2019 11:55:30 +0200

gpsd (3.17-6) unstable; urgency=medium

  * [0a8e4e18] Pull json fixes from upstream to fix a stack-based
    buffer overflow, which may allow remote attackers to execute
    arbitrary code on embedded platforms via traffic on Port
    2947/TCP or crafted JSON inputs.
    CVE-2018-17937 / Closes: #925327
    The update also fixes several other json parser bugs.
    - ECMA-404 says JSON \u must have 4 hex digits
    - Allow for \u escapes with fewer than 4 digits.
    - Fail on bad escape string.
  * [71020f4f] Update git-buildpackage config to build from the
    buster branch.

 -- Bernd Zeimetz <bzed@debian.org>  Fri, 05 Apr 2019 23:31:30 +0200

gpsd (3.17-5) unstable; urgency=medium

  * [fd1e83f9] Add pkg-config as Build-Dependency.
    Went missing somehow :(
  * [6d0e69e3] Build with default compiler standard
  * [8994d7cb] Actually change control.in, not control.
    Needs an extra check to make sure I don't forget again :)
  * [a744cad9] Updating debian/control from debian/control.in

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 28 Dec 2017 00:57:01 +0100

gpsd (3.17-4) unstable; urgency=medium

  * [cbbe97a4] Build against QT5.
    Thanks to Lisandro Damián Nicanor Pérez Meyer (Closes: #874905)
  * [aed76eeb] Depend on python-gi. (Closes: #885297)

 -- Bernd Zeimetz <bzed@debian.org>  Tue, 26 Dec 2017 12:35:25 +0100

gpsd (3.17-3) unstable; urgency=medium

  * [2638b3e] Avoid duplicate ppscheck installation.
    Thanks to Andreas Beckmann (Closes: #879951)

 -- Bernd Zeimetz <bzed@debian.org>  Fri, 27 Oct 2017 17:26:55 +0200

gpsd (3.17-2) unstable; urgency=medium

  * Uploading to unstable.
  * [a13df427] Fixing last changelog entry.
    Some lines went missing, oops.

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 26 Oct 2017 23:16:41 +0200

gpsd (3.17-1) experimental; urgency=medium

  * [d21fbf15] Updated version 3.17 from 'upstream/3.17'
    with Debian dir 3099dc33257e902647917f2ad7e67eec078b0b42
  * [913ea95c] Fix SConstruct.
  * [d9d7b300] Python dbg _d.so files are not built anymore.
  * [f0ea0948] Install ppscheck + manpage
  * [7df3aa0a] Updating symbols files

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 21 Oct 2017 16:12:28 +0200

=== debian/rules ===
#!/usr/bin/make -f

#uncomment if debhelper should be verbose
#export DH_VERBOSE=1

DEBIAN_VERSION := $(strip $(shell dpkg-parsechangelog| awk '/Version/{print $$2}'))

LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConstruct | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))


LIBGPS_DEBIAN_FILE_SOURCES := $(strip $(shell ls -1 debian/*LIBGPSSONAME* ))
LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g'))

#python versions
PYTHONS := $(shell pyversions -vr)
PYTHON_DEFAULT := $(strip $(shell pyversions -vd))

#debhelper version and settings needed for udev
DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')
LSB_RELEASE := $(shell lsb_release -si)
UDEV_BREAKS =

ifeq (Debian,$(strip $(LSB_RELEASE))) ## debian ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.3.15; echo $$?)))
UDEV_BREAKS = 125
endif
else ## not debian ##
ifeq (Ubuntu,$(strip $(LSB_RELEASE))) ## ubuntu ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.0.17ubuntu2; echo $$?)))
UDEV_BREAKS = 136-1
endif
endif ## ubuntu ##
endif ## debian ##


DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SCONSOPTS = \
	prefix=/usr \
	systemd=yes \
	nostrip=yes \
	dbus_export=yes \
	docdir=/usr/share/doc/gpsd \
	libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	gpsd_user=gpsd \
	gpsd_group=dialout \
	qt_versioned=5


ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += debug=yes
else
	SCONSOPTS += debug=no
endif

#package names
PACKAGE_GPSD := gpsd
PACKAGE_CLIENTS := gpsd-clients
PACKAGE_LIB := libgps$(LIB_soname)
PACKAGE_QTLIB := libqgpsmm$(LIB_soname)
PACKAGE_LIB_DEV := libgps-dev
PACKAGE_QTLIB_DEV := libqgpsmm-dev
PACKAGE_PY := python-gps
PACKAGE_GPSDDBG := gpsd-dbg


cflags := $(shell dpkg-buildflags --get CFLAGS)
cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)

SCONS_ENV := set -e ;\
		export LDFLAGS="$(ldflags)" ;\
		export CFLAGS="$(cflags)" ;\
		export CXXFLAGS="$(cxxflags)" ;\
		export CPPFLAGS="$(cppflags)";


$(LIBGPS_DEBIAN_FILE_TARGETS): $(LIBGPS_DEBIAN_FILE_SOURCES)
	for source in $(LIBGPS_DEBIAN_FILE_SOURCES); do \
	    target=$$(echo "$$source" | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g') ;\
	    sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' "$$source" > "$$target" ;\
	done

debian/control: debian/control.in
		rm -f $@ 
		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' $< > $@ 
		if [ -d .git ]; then \
			git add debian/control ;\
			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
		fi ;\

SConstruct.deb_revision: SConstruct
	if [ ! -f $@ ]; then \
		cp $< $@ ;\
		sed -i '/^revision=/s/%(.*)/%("$(DEBIAN_VERSION)",)/' $< ;\
	fi
	touch $@

build-indep: build
build-arch: build

build: build-stamp build-static-stamp
build-stamp: SConstruct.deb_revision
	set -e; \
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) python$${py} /usr/bin/scons $(SCONSOPTS); \
	    done
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# disable tests on hurd due to weird ipv6 errors
	# http://deb.li/4C46AEAC.7040906@bzed.de
ifeq (,$(findstring hurd,$(DEB_HOST_ARCH_OS)))
	-$(SCONS_ENV) /usr/bin/scons check
endif
endif
	# ensure the test tools are built
	$(SCONS_ENV) python /usr/bin/scons $(SCONSOPTS) $(shell grep test_ debian/gpsd-dbg.install | grep -v '\.py' | awk '{print $$1}')
	touch $@

build-static-stamp: SConstruct.deb_revision
	cp libgps_static.a libgps.a
	touch $@

clean: debian/control
	dh_testdir
	dh_testroot
	set -e; \
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) python$${py} /usr/bin/scons $(SCONSOPTS) --clean ; \
	    done
	$(SCONS_ENV) python /usr/bin/scons $(SCONSOPTS) sconsclean || true
	# revert revision changes in SConstruct
	if [ -f SConstruct.deb_revision ]; then \
	    mv SConstruct.deb_revision SConstruct; \
	fi
	rm -rf \
	    .sconf_temp \
	    .scons-option-cache \
	    .sconsign.dblite \
	    gps/*.pyc \
	    TROUBLESHOOTING \
	    debian/buildinfo.gz \
	    config.log \
	    debian/shlibs.local \
	    leapsecond.pyc \
	    libgps.a \
	    $(LIBGPS_DEBIAN_FILE_TARGETS)
	dh_clean

install: install-stamp
install-stamp: build-stamp build-static-stamp $(LIBGPS_DEBIAN_FILE_TARGETS)
	dh_testdir
	dh_testroot
	dh_prep
	set -e ;\
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp python$${py} /usr/bin/scons install $(SCONSOPTS) ;\
	    done
	# install static lib
	cp libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	cp INSTALL TROUBLESHOOTING
	# install systemd files
	mkdir -p debian/tmp/lib/systemd/system
	cp systemd/* debian/tmp/lib/systemd/system
	# fix various manpages
	for i in cgps.1 gegps.1 lcdgps.1 xgps.1 xgpsspeed.1 gpxlogger.1; do \
	    rm -f debian/tmp/usr/share/man/man1/$$i ;\
	    ln -s gps.1 debian/tmp/usr/share/man/man1/$$i ;\
	done
	rm -f debian/tmp/usr/share/man/man3/libQgpsmm.3
	ln -s libgpsmm.3.gz debian/tmp/usr/share/man/man3/libQgpsmm.3.gz
	# install everything
	dh_install --fail-missing
	# remove rpaths
	find debian -type f -exec file {} \; |\
	    grep ELF |\
	    grep 'dynamically linked' |\
	    sed 's,:.*,,' |\
	    xargs chrpath -d
	touch $@


install-indep: install
install-arch: install

binary: install-stamp
	dh_testdir
	dh_testroot
	dh_installchangelogs  NEWS
	dh_installdocs 
	dh_installman 
	dh_installmenu 
	dh_systemd_enable -pgpsd
	dh_installinit
	dh_systemd_start -pgpsd --restart-after-upgrade
	dh_installexamples 
	chmod 755 debian/$(PACKAGE_PY)/usr/lib/python*/*-packages/gps/gps.py
	dh_python2 -Ngpsd -Ngpsd-clients -Ngpsd-dbg
	dh_python2 -pgpsd-dbg usr/lib/gpsd/debug
	dh_python2 -pgpsd-clients usr/bin
	dh_python2 -pgpsd lib/udev/
	cp $(CURDIR)/gpsd.rules $(CURDIR)/debian/gpsd.udev
	dh_installudev 
	dh_link 
	dh_strip --dbgsym-migration='gpsd-dbg (<< 3.16-4~)'
	dh_buildinfo -p$(PACKAGE_GPSDDBG)
	dh_compress 
	dh_fixperms  -Xgpsd.hotplug
	dh_lintian
ifeq (,$(DEB_BUILD_OPTIONS))
	dh_makeshlibs -Nlibqgpsmm$(LIBGPS_SONAME) -- -c4
	dh_makeshlibs -plibqgpsmm$(LIBGPS_SONAME) -- -c1
else
	dh_makeshlibs
endif
	dh_shlibdeps 
ifneq (,$(UDEV_BREAKS))
	echo "gpsd:Breaks=udev (<< $(UDEV_BREAKS))" >> $(CURDIR)/debian/gpsd.substvars
endif
	dh_gencontrol 
	dh_installdeb 
	dh_md5sums 
	dh_builddeb 


binary-indep: binary
binary-arch: binary

.PHONY: binary binary-indep binary-arch \
	install install-arch install-indep \
	clean \
	build debian/control

## gpsd 3.19

=== debian/changelog ===
gpsd (3.19-1) experimental; urgency=medium

  [ Christian Ehrhardt ]
  * [d61040a0] d/usr.sbin.gpsd: Relicense to BSD to match the Project.
    As the Author of the profile I'm relicensing the apparmor profile
    to the BSD License to match the (majority) of the rest of the
    GPSD project licenses.
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * [5de17f0c] Allow gpsd.service to be enabled by the admin at boot time.
    Be sure to keep it disabled. The admin needs to explicitely start
    it if needed. (Closes: #928681)

  [ Bernd Zeimetz ]
  * [7a45f357] Update upstream source from tag 'upstream/3.19'
    Update to upstream version '3.19'
    with Debian dir b3aea49f5d39c5eb18ffcb61a2b6cebae7f7322f
  * [63e0cd09] snapshot changelog
  * [5e3a1568] test script location changed
  * [9035f8d9] add test_misc.py
  * [6d9ccaf3] Add gpsrinex
  * [764bfeaa] Updating symbol files

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 11 Jul 2019 10:01:16 +0200

gpsd (3.18.1-1) experimental; urgency=medium

  [ Christian Ehrhardt ]
  * Lintian/Standarts/Compat-level fixes
    - [7f88e6a6] d/copyright: update to dep-5 format and for project changes
    - [1260d1f4] d/p/series: mention the purpose of add_patch.sh
    - [900bdc19] d/patches/gpsd_hotplug_rules_disable_generic_serial_converters
      add dep-3 header
    - [03a2b421] add minimal header to debian/patches/full-systemd-support
    - [6759d5f2] d/gpsd.init: remove sysV to not jeopardize socket activation
    - [090182f8] d/gpsd.maintscript: clean up dropped sysV init (conffile)
    - [405bf8c1] add autopkgtest to verify service/socket
    - [373e3f23] d/rules: use pkg-info.mk to detect the package version
    - [8022d1d5] d/p/python3_support_in-SConstruct: add minimal dep-3 patch
      header
    - [00b447e6] d/control{.in}: point to current packaging repo with secure url
    - [7640cb28] d/control{.in}: update debhelper build dependencies per lintian
      warnings
    - [1b87b0c0] d/rules, d/control{.in}: do not depend on qt5-default meta
      package
    - [b7db9f61] d/source/lintian-overrides: mark gpsd-dbg not being a package
      with debug symbols
    - [7e4513b8] d/gpsd.{pre,post}{rm,inst}: drop code only needed for upgrades
      from oldoldstable
    - [53f3ec60] d/compat: bump to compat 11, no further changes needed
    - [40505722] standards-version 3.9.8: switch deprecated menu to FreeDesktop
      entries
    - [3d6613a5] standards-version 4.0.0: do not build man pages if nodoc is set
      in DEB_BUILD_OPTIONS
    - [dd9396d4] standards-version 4.0.1: Use priority 'optional' instead of
      deprecated priority 'extra'
    - [d3563a42] debian/watch: use https and signature verification
    - [397d7744] d/control{.in}: bump Standards-Version to 4.2.1
    - [cd2c0ad1] d/rules: switch to dh_missing to prepare for compat 12
    - [2e9946c7] d/rules: use dh_installsystemd for compat >=11
    - [0031cfc8] d/control{.in}: simplify by dropping conflicts/breaks not even
      in oldoldstable anymore
  * complete python3 support that was started in 3.17-6 (Closes: #883286)
    - [30da0ff0] d/control{.in}: fix duplicate-long-description in
      python[3]-gps packages
    - [c088a6d7] d/control.in: add missing python3 changes
    - [96a7df91] d/control{.in}: scons for python3 will need >=3.5
    - [cf5d6e63] d/control{.in}: remove ancient X-Python-Version
    - [f15fbbe8] d/rules: scons need target_python set for py2/py3
    - [91daffd9] d/python3-gps.install: follow subversion specific py3 shared
      objects naming convention
    - [f53cd4a2] d/control{.in}: let gpsd-clients also depend on python3 bits
    - [fd7ff117] d/control{.in}, d/gpsd-clients.install, d/python3-gps.install:
      tools gpscat, gpsfake and gpsprof are python2 and part of the cli tools,
      so move them from python3-gps to gpsd-clients
    - [69de7b75] d/control: add ${python3:Depends} to gpsd-clients in case
      upstream switches to python3
    - [2f1dc482] d/control{.in}: add python dependencies not picked up by
      dh_python
    - [25a79e9f] d/control{.in}: remove manual python dependency
      python:Depends will take care
    - [02c1d28c] d/rules: remap wrong install prefix enforced by scons
  * [fd58e624] New upstream version 3.18.1
    - [0abe62cb] d/p/full-systemd-support: update for 3.18.1
    - [d6e6fe9a] d/p/python3_support_in-SConstruct: dropped as it is in 3.18.1
    - [324d2966] d/control{.in}: add python dependencies for better checks in
      3.18.1
    - [7fd30c38] d/gpsd-clients.install: add new ubxtool and zerk to manage
      JAVAD and u-blox GPS
    - [1caba4b3] d/libgpsLIBGPSSONAME.symbols: update symbols to 3.18
    - [6eb6d26a] d/libqgpsmmLIBGPSSONAME.symbols: update symbols to 3.18
  * [d5ee2b3e] d/control[.in}, d/rules, d/usr.sbin.gpsd, d/gpsd.install: add
    apparmor profile for gpsd

  [ Bernd Zeimetz ]
  * [cc886877] Depend on the fixed scons version
  * [3ad7153a] Delete __pycache__ in clean target.
  * [b27def48] Add the build-in-debian .travis.yml again

  [ Christian Ehrhardt ]
  * [981b512c] d/t/control: mark test to require container.
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>
  * [35763ca7] d/t/control: mark all binaries we need as dependencies (expect no base system to be present)
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>
  * [950c3576] d/libgpsLIBGPSSONAME.install: use generated LIBGPSSONAME version.
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>
  * [d8942ba4] - d/rules, d/libgpsLIBGPSSONAME.install: replace libgps.so.LIBGPSSONAME with a quirk to avoid issues by broken fakeroot.
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>

  [ Bernd Zeimetz ]
  * [32ffa216] Let autopkgtest not fail build on travis.
  * [da9c1c8a] Use $(LIBGPS_SONAME) instead of hardcoded soname.
  * [a481720a] Updating debian/control from debian/control.in


=== debian/control ===
Source: gpsd
Section: misc
Priority: optional
Maintainer: Bernd Zeimetz <bzed@debian.org>
Build-Depends: debhelper (>= 11),
 po-debconf,
 python-all-dev (>= 2.6.6-3),
 python-all-dbg (>= 2.6.6-3),
 python3-all-dev,
 python-cairo-dev,
 python3-cairo-dev,
 python-serial,
 python3-serial,
 python-gi,
 python3-gi,
 xsltproc, docbook-xsl, docbook-xml,
 libncurses-dev,
 libusb-1.0-0-dev [!hurd-any],
 libdbus-1-dev, libglib2.0-dev, libdbus-glib-1-dev, makedev,
 libbluetooth-dev [linux-any],
 qtbase5-dev,
 lsb-release, bc,
 dpkg-dev (>= 1.15.6),
 scons (>= 3.0.1-2~), chrpath,
 dh-buildinfo,
 dh-python,
 dh-apparmor,
 pps-tools (>= 0.20120406+g0deb9c7e-2~) [linux-any],
 pkg-config
Standards-Version: 4.2.1
Homepage: http://www.catb.org/gpsd/
Vcs-Browser: https://github.com/bzed/pkg-gpsd
Vcs-Git: https://github.com/bzed/pkg-gpsd.git
X-Python3-Version: >= 3.5

Package: gpsd
Architecture: any
Depends: netbase | systemd-sysv, lsb-base (>= 3.2-13),
 adduser (>= 3.34),
 ${shlibs:Depends}, ${misc:Depends},
 libgps25 (= ${binary:Version})
Recommends: udev [linux-any], ${python:Depends}, python
Breaks: ${gpsd:Breaks}
Suggests: gpsd-clients, dbus, apparmor
Conflicts: fso-gpsd
Multi-Arch: foreign
Description: Global Positioning System - daemon
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 With gpsd, multiple GPS client applications can share access to devices
 without contention or loss of data. Also, gpsd responds to queries with a
 format that is substantially easier to parse than the different standards
 emitted by GPS devices.

Package: gpsd-dbg
Architecture: any
Section: debug
Suggests: gpsd-dbgsym
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 libgps25 (= ${binary:Version}) | gpsd (= ${binary:Version}) | gpsd-clients (= ${binary:Version}) | python-gps (= ${binary:Version})
Description: Global Positioning System - debugging symbols
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the python debug modules and some test tools
 to the debug the behaviour of gpsd. Debug symbols are being shipped
 in the dbgsym package.

Package: gpsd-clients
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libgps25 (= ${binary:Version}),
 python-gps, python3-gps, python-gtk2, python-cairo, gir1.2-gtk-3.0, python-serial, python-gi-cairo, ${python:Depends}, ${python3:Depends}
Suggests: gpsd
Conflicts: gps
Breaks: ${python:Breaks}, python-gps (<<3.18.1-1)
Replaces: python-gps (<<3.18.1-1)
Description: Global Positioning System - clients
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains auxiliary tools and example clients for monitoring,
 testing, latency-profiling, device configuration and simulating gpsd.

Package: python-gps
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 python (>= 2.6) | python-simplejson
Recommends: gpsd
Provides: ${python:Provides}
Breaks: ${python:Breaks}, gpsd-clients (<<3.18.1-1)
Conflicts: python-json
Description: Global Positioning System - Python 2 libraries
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains a Python 2 interface to connect to gpsd, together with
 a module providing a controlled testing environment.

Package: python3-gps
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Recommends: gpsd
Provides: ${python:Provides}
Breaks: ${python:Breaks}
Description: Global Positioning System - Python 3 libraries
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains a Python 3 interface to connect to gpsd, together with
 a module providing a controlled testing environment.

Package: libgps25
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gpsd
Conflicts: fso-gpsd
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Global Positioning System - library
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libgps, a C service library for querying GPS
 devices. It supports both a low-level interface, which communicates
 directly with the device to which the GPS is connected, and a high-level
 interface, which goes through gpsd and is intended for concurrent use by
 several applications.

Package: libgps-dev
Architecture: any
Section: libdevel
Depends: libgps25 (= ${binary:Version}), ${misc:Depends}, pkg-config
Description: Global Positioning System - development files
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the header and development files needed to build
 programs and packages using libgps.

Package: libqgpsmm25
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Global Positioning System - Qt wrapper for libgps
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libQgpsmm, the Qt version of libgpsmm.
 It is a wrapper over libgps, the service library for querying GPS
 devices. libQgpsmm is available on all platforms which are supported
 by Qt4.

Package: libqgpsmm-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, pkg-config,
 libqgpsmm25 (= ${binary:Version}),
 libgps-dev (= ${binary:Version})
Description: Global Positioning System - Qt wrapper for libgps (development)
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides the development file for libQgpsmm, the Qt version of
 libgpsmm. It contains pkgconfig and qmake bits to build with the library.

=== debian/rules ===
--- 
+++ 
@@ -1,19 +1,19 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/pkg-info.mk
 
 #uncomment if debhelper should be verbose
 #export DH_VERBOSE=1
 
-DEBIAN_VERSION := $(strip $(shell dpkg-parsechangelog| awk '/Version/{print $$2}'))
-
 LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConstruct | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))
 
+export QT_SELECT=qt5
 
 LIBGPS_DEBIAN_FILE_SOURCES := $(strip $(shell ls -1 debian/*LIBGPSSONAME* ))
 LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g'))
 
 #python versions
-PYTHONS := $(shell pyversions -vr)
-PYTHON_DEFAULT := $(strip $(shell pyversions -vd))
+PYTHONS := $(shell pyversions -r) $(shell py3versions -r)
 
 #debhelper version and settings needed for udev
 DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')
@@ -46,6 +46,9 @@
 	gpsd_group=dialout \
 	qt_versioned=5
 
+ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
+	SCONSOPTS += manbuild=no
+endif
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 	SCONSOPTS += debug=yes
@@ -61,6 +64,7 @@
 PACKAGE_LIB_DEV := libgps-dev
 PACKAGE_QTLIB_DEV := libqgpsmm-dev
 PACKAGE_PY := python-gps
+PACKAGE_PY3 := python3-gps
 PACKAGE_GPSDDBG := gpsd-dbg
 
 
@@ -83,8 +87,8 @@
 	done
 
 debian/control: debian/control.in
-		rm -f $@ 
-		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' $< > $@ 
+		rm -f $@
+		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' $< > $@
 		if [ -d .git ]; then \
 			git add debian/control ;\
 			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
@@ -93,7 +97,7 @@
 SConstruct.deb_revision: SConstruct
 	if [ ! -f $@ ]; then \
 		cp $< $@ ;\
-		sed -i '/^revision=/s/%(.*)/%("$(DEBIAN_VERSION)",)/' $< ;\
+		sed -i '/^revision=/s/%(.*)/%("$(DEB_VERSION)",)/' $< ;\
 	fi
 	touch $@
 
@@ -104,7 +108,7 @@
 build-stamp: SConstruct.deb_revision
 	set -e; \
 	    for py in $(PYTHONS); do \
-	    	$(SCONS_ENV) python$${py} /usr/bin/scons $(SCONSOPTS); \
+	    	$(SCONS_ENV) $${py} /usr/bin/scons $(SCONSOPTS) target_python=$${py} ; \
 	    done
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 	# disable tests on hurd due to weird ipv6 errors
@@ -126,7 +130,7 @@
 	dh_testroot
 	set -e; \
 	    for py in $(PYTHONS); do \
-	    	$(SCONS_ENV) python$${py} /usr/bin/scons $(SCONSOPTS) --clean ; \
+	    	$(SCONS_ENV) $${py} /usr/bin/scons $(SCONSOPTS) target_python=$${py} --clean ; \
 	    done
 	$(SCONS_ENV) python /usr/bin/scons $(SCONSOPTS) sconsclean || true
 	# revert revision changes in SConstruct
@@ -144,7 +148,8 @@
 	    debian/shlibs.local \
 	    leapsecond.pyc \
 	    libgps.a \
-	    $(LIBGPS_DEBIAN_FILE_TARGETS)
+	    $(LIBGPS_DEBIAN_FILE_TARGETS) \
+	    __pycache__
 	dh_clean
 
 install: install-stamp
@@ -154,7 +159,7 @@
 	dh_prep
 	set -e ;\
 	    for py in $(PYTHONS); do \
-	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp python$${py} /usr/bin/scons install $(SCONSOPTS) ;\
+	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp $${py} /usr/bin/scons install $(SCONSOPTS) target_python=$${py} ;\
 	    done
 	# install static lib
 	cp libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
@@ -169,8 +174,17 @@
 	done
 	rm -f debian/tmp/usr/share/man/man3/libQgpsmm.3
 	ln -s libgpsmm.3.gz debian/tmp/usr/share/man/man3/libQgpsmm.3.gz
+	# scons insists on python artifactes being placed in /usr/local despite
+	# prefix settings, fix this up before dh*install
+	mkdir -p debian/tmp/usr/lib/
+	mv -v debian/tmp/usr/local/lib/* debian/tmp/usr/lib/
 	# install everything
-	dh_install --fail-missing
+	dh_install
+	# quirk to avoid issues by broken fakeroot misdetecting links as files and
+	# then breaking dh_install -> cp -a fatally
+	ln -s libgps.so.$(LIBGPS_SONAME).0.0 debian/libgps$(LIBGPS_SONAME)/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
+	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
+	dh_missing --fail-missing
 	# remove rpaths
 	find debian -type f -exec file {} \; |\
 	    grep ELF |\
@@ -187,24 +201,31 @@
 	dh_testdir
 	dh_testroot
 	dh_installchangelogs  NEWS
-	dh_installdocs 
-	dh_installman 
-	dh_installmenu 
-	dh_systemd_enable -pgpsd
+	dh_installdocs
+	dh_installman
+	dh_installmenu
+	dh_apparmor --profile-name=usr.sbin.gpsd -pgpsd
+	dh_installsystemd -pgpsd --restart-after-upgrade gpsdctl@.service gpsd.socket
+	dh_installsystemd -pgpsd --no-enable --no-start gpsd.service
 	dh_installinit
-	dh_systemd_start -pgpsd --restart-after-upgrade
-	dh_installexamples 
-	chmod 755 debian/$(PACKAGE_PY)/usr/lib/python*/*-packages/gps/gps.py
+	dh_installsystemd -pgpsd --restart-after-upgrade
+	dh_installexamples
+	chmod 755 debian/$(PACKAGE_PY)/usr/lib/python2*/*-packages/gps/gps.py
+	chmod 755 debian/$(PACKAGE_PY3)/usr/lib/python3*/*-packages/gps/gps.py
 	dh_python2 -Ngpsd -Ngpsd-clients -Ngpsd-dbg
 	dh_python2 -pgpsd-dbg usr/lib/gpsd/debug
 	dh_python2 -pgpsd-clients usr/bin
 	dh_python2 -pgpsd lib/udev/
+	dh_python3 -Ngpsd -Ngpsd-clients -Ngpsd-dbg
+	dh_python3 -pgpsd-dbg usr/lib/gpsd/debug
+	dh_python3 -pgpsd-clients usr/bin
+	dh_python3 -pgpsd lib/udev/
 	cp $(CURDIR)/gpsd.rules $(CURDIR)/debian/gpsd.udev
-	dh_installudev 
-	dh_link 
+	dh_installudev
+	dh_link
 	dh_strip --dbgsym-migration='gpsd-dbg (<< 3.16-4~)'
 	dh_buildinfo -p$(PACKAGE_GPSDDBG)
-	dh_compress 
+	dh_compress
 	dh_fixperms  -Xgpsd.hotplug
 	dh_lintian
 ifeq (,$(DEB_BUILD_OPTIONS))
@@ -213,14 +234,14 @@
 else
 	dh_makeshlibs
 endif
-	dh_shlibdeps 
+	dh_shlibdeps
 ifneq (,$(UDEV_BREAKS))
 	echo "gpsd:Breaks=udev (<< $(UDEV_BREAKS))" >> $(CURDIR)/debian/gpsd.substvars
 endif
-	dh_gencontrol 
-	dh_installdeb 
-	dh_md5sums 
-	dh_builddeb 
+	dh_gencontrol
+	dh_installdeb
+	dh_md5sums
+	dh_builddeb
 
 
 binary-indep: binary
